## msxpertsuite 5.1.1

=== debian/changelog ===
msxpertsuite (5.1.1-1) unstable; urgency=low

  * New upstream release.

  * Fix bug with the failing mass spectrometric data file slicer.

  * Fix bug with the deconvolution of the isotopic cluster.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 24 May 2018 18:40:18 +0200

=== debian/control ===
Source: msxpertsuite
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper (>=9.20130630),
               dpkg-dev (>= 1.16.1~),
               graphicsmagick-imagemagick-compat,
               libgomp1,
               rubber (>= 1.4),
               qtbase5-dev (>= 5.7.0),
               libqt5svg5-dev (>= 5.7.0),
               qtscript5-dev (>= 5.7.0),
               cmake (>= 3.2.2-2),
               texlive-latex-recommended,
               biber,
               latex2html,
               texlive-fonts-recommended,
							 texlive-lang-french,
							 texlive-lang-cyrillic,
               libqcustomplot-dev(>= 1.3.2),
               libpwiz-dev(>=3.0.10827),
               libboost-dev (>= 1.56.0),
               docbook-to-man,
               libtclap-dev,
               gsfonts,
               doxygen,
               graphviz,
               qttools5-dev-tools,
               qtchooser
Standards-Version: 4.1.3
Homepage: https://www.msxpertsuite.org/
Vcs-Browser: https://salsa.debian.org/debichem-team/msxpertsuite.git
Vcs-Git: https://salsa.debian.org/debichem-team/msxpertsuite.git

Package: massxpert
Depends: msxpertsuite, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         msxpertsuite-data (>= ${source:Upstream-Version}),
         msxpertsuite-data (<< ${source:Upstream-Version}A~)
Replaces: massxpert (<< 3.6.2)
Breaks: massxpert (<< 3.6.2)
Conflicts: massxpert (<< 3.6.2)
Suggests: msxpertsuite-doc
Description: mass spectrometry software suite - executable files
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 Three programs, massXpert, mineXpert and convXpert allow the following:
 .
 massXpert:
  - making brand new polymer chemistry definitions;
  - using the definitions to perform easy calculations in a desktop
    calculator-like manner;
  - performing sophisticated polymer sequence editing and simulations;
  - perform m/z list comparisons;
 .
 Chemical simulations encompass cleavage (either chemical or
 enzymatic), gas-phase fragmentations, chemical modification of any
 monomer in the polymer sequence, cross-linking of monomers in the
 sequence, arbitrary mass searches, calculation of the isotopic
 pattern...
 .
 mineXpert:
  - Open mass spectrometry data files (mzML, mzXML, asc, xy, ...);
  - Calculate and display the TIC chromatogram;
  - For mobility data, calculate and display a mz=f(dt) color map;
  - Integrate the data from the TIC chromatogram or color map
    - to mass spectrum;
    - to drift spectrum;
    - back to TIC chromatogram (XIC chromatogram);
    - reverse operations;
  - Export the data to text files;
  - Slice a big initial file into smaller chunks for easier mining;
  - Define how mining activity is recorded on disk for later use;
  - Convert mzML files into a private (albeit open) mass spectrometry
    format that allows better performance (based on SQLite3).
 .
 This package contains the binary programs.

Package: massxpert-data
Depends: msxpertsuite-data, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite-data
Architecture: all
Depends: ${misc:Depends}
Replaces: massxpert-data (<< 3.6.2)
Breaks: massxpert-data (<< 3.6.2)
Conflicts: massxpert-data (<< 3.6.2)
Description: mass spectrometry software suite - arch-indep data
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the architecture-independent data required for
 the proper functioning of msxpertsuite. For example, polymer chemistry
 definition files are in this package, for use with the massxpert program.

Package: massxpert-doc
Depends: msxpertsuite-doc, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: optional
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: msxpertsuite-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Replaces: massxpert-doc (<< 3.6.2)
Breaks: massxpert-doc (<< 3.6.2)
Conflicts: massxpert-doc (<< 3.6.2)
Description: mass spectrometry software suite - manuals
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the manuals in PDF format.

Package: msxpertsuite-dev-doc
Section: doc
Architecture: all
Depends: libjs-jquery, ${misc:Depends}
Conflicts: msxpertsuite-devdoc
Replaces: msxpertsuite-devdoc
Description: mass spectrometry software suite - developer doc
 msXpertSuite is a collection of programs to simulate and analyse mass
 spectrometric data obtained on linear (bio-)polymers. It is the
 successor of GNU polyXmass, first, and of massXpert, second.
 .
 This package contains the developer doxygen-based doc.

=== debian/rules ===
#!/usr/bin/make -f
# Based on the initial work of Joey Hess and Craig Small.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

CMAKE=/usr/bin/cmake

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

BUILD_DIR = $(CURDIR)/debian/build

INSTALL_INDEP_DIR = $(CURDIR)/debian/tmp-indep
INSTALL_ARCH_DIR = $(CURDIR)/debian/tmp-arch

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CXXFLAGS += -O0
else
	CXXFLAGS += -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

$(info "---------------------------------------")
$(info NUMJOBS: $(NUMJOBS))
$(info MAKEFLAGS: $(MAKEFLAGS))
$(info DEB_BUILD_OPTIONS: $(DEB_BUILD_OPTIONS))
$(info "---------------------------------------")

# Hardening stuff for debhelper compat level 9, see
# http://wiki.debian.org/Hardening

# To enable all, uncomment following line
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

.NOTPARALLEL:

.PHONY: clean
clean:
	dh_testdir
	dh_testroot

	dh_clean

# The following is for the binary software
	rm -rf $(BUILD_DIR)
	rm -rf $(INSTALL_INDEP_DIR) $(INSTALL_ARCH_DIR)

# Remove the generated files (even if by CMake).
	rm -f msxpertsuite-doc.7 \
	 massxpert/data/msxpertsuite-data.7 \
	 massxpert/massxpert.1 \
	 minexpert/minexpert.1

# The user manuals, after creation in the build tree are exported to the source
# tree. Remove them.
	rm -f massxpert/user-manual/massxpert-doc.pdf \
		minexpert/user-manual/minexpert-doc.pdf

# Remove all the doxygen-generated developer documentation.
	rm -rf devdoc/html

build-indep-stamp:
	dh_testdir
	dh_prep -i

	rm -rf $(INSTALL_INDEP_DIR)
	mkdir -p $(BUILD_DIR)

# The following is for building of the user manual
	cd $(BUILD_DIR) && \
	$(CMAKE) \
	-DOPENMP=1 \
	-DDEBUG=1 \
	-DBUILD_USER_MANUALS=1 \
	-DCMAKE_INSTALL_PREFIX=/usr ../..

	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert-user-manual

	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert-user-manual

	# The qthelp target depends on the devdoc target
	# that is responsible for compiling the Doxygen-based documentation
	cd $(BUILD_DIR) && $(MAKE) qthelp

	rm devdoc/html/jquery.js

	find devdoc/html -name "*.md5" | xargs rm

	touch build-indep-stamp


build-arch-stamp:
	dh_testdir
	dh_prep -a

	rm -rf $(INSTALL_ARCH_DIR)
	mkdir -p $(BUILD_DIR)

# The following is for building of the binary msxpertsuite software
	cd $(BUILD_DIR) && \
	$(CMAKE) \
	-DOPENMP=1 \
	-DDEBUG=1 \
	-DBUILD_USER_MANUALS=0 \
	-DCMAKE_INSTALL_PREFIX=/usr ../..

	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert
	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert

	touch build-arch-stamp


.PHONY: build
build: build-indep-stamp build-arch-stamp

.PHONY: build-indep
build-indep: build-indep-stamp

.PHONY: build-arch
build-arch: build-arch-stamp


install-indep-stamp: build-indep-stamp
	dh_testdir
	dh_testroot
	dh_installdirs -i

	mkdir -p $(INSTALL_INDEP_DIR)

# The general doc stuff
	$(MAKE) -C $(BUILD_DIR)/doc install DESTDIR=$(INSTALL_INDEP_DIR)

# But, now remove the license file
	rm $(INSTALL_INDEP_DIR)/usr/share/doc/msxpertsuite/COPYING

# Finally the indep data
	$(MAKE) -C $(BUILD_DIR)/massxpert/data install DESTDIR=$(INSTALL_INDEP_DIR)

# The user manuals

	$(MAKE) -C $(BUILD_DIR)/massxpert/user-manual install DESTDIR=$(INSTALL_INDEP_DIR)
#	DESTDIR=$(INSTALL_INDEP_DIR) $(CMAKE) -DCOMPONENT=usermanual -P $(BUILD_DIR)/massxpert/cmake_install.cmake

	$(MAKE) -C $(BUILD_DIR)/minexpert/user-manual install DESTDIR=$(INSTALL_INDEP_DIR)
#	DESTDIR=$(INSTALL_INDEP_DIR) $(CMAKE) -DCOMPONENT=usermanual -P $(BUILD_DIR)/minexpert/cmake_install.cmake

	touch install-indep-stamp


install-arch-stamp: build-arch-stamp
	dh_testdir
	dh_testroot
	dh_installdirs -a

	mkdir -p $(INSTALL_ARCH_DIR)

	# $(MAKE) -C $(BUILD_DIR)/massxpert install DESTDIR=$(INSTALL_ARCH_DIR)
	DESTDIR=$(INSTALL_ARCH_DIR) $(CMAKE) -DCOMPONENT=arch -P $(BUILD_DIR)/massxpert/cmake_install.cmake

	# $(MAKE) -C $(BUILD_DIR)/minexpert install DESTDIR=$(INSTALL_ARCH_DIR)
	DESTDIR=$(INSTALL_ARCH_DIR) $(CMAKE) -DCOMPONENT=arch -P $(BUILD_DIR)/minexpert/cmake_install.cmake

	# Install menu pixmap
	install -o root -g root -d $(INSTALL_ARCH_DIR)/usr/share/pixmaps
	install -o root -g root -m 644 \
		$(CURDIR)/images/msxpertsuite-icon-32.xpm \
		$(INSTALL_ARCH_DIR)/usr/share/pixmaps/msxpertsuite-icon-32.xpm

	touch install-arch-stamp


# Build architecture-independent files here.
.PHONY: binary-indep
binary-indep: install-indep-stamp
	dh_prep -i
	dh_testdir -i
	dh_testroot -i
	dh_installchangelogs -i

# symlink the jquery.js file
	dh_link -i
	dh_installdocs -i
	dh_install -i
	dh_installman -i
	dh_compress -Xmassxpert-doc.pdf -Xminexpert-doc.pdf -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
.PHONY: binary-arch
binary-arch: install-arch-stamp
	dh_prep -a
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs  -a
	dh_installdocs -a
	dh_install -a
	dh_installman -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a


.PHONY: binary
binary: binary-indep binary-arch

## msxpertsuite 5.2.0

=== CMakeLists.txt ===
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.0)

# Add folder where are supportive functions
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeStuff)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

# We want C++14
ADD_DEFINITIONS(-std=c++14 -Wno-unknown-pragmas)

# Include the various colors we want to use in the output
include(outputColors)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(systemUname)


############################################################
# Basic information about project

project(msXpertSuite)
set(VERSION 5.2.0)


# Set additional project information
set(COMPANY "msXpertSuite.org")
set(COPYRIGHT "Copyright (c) 2008-2018 Filippo Rusconi. Licensed under GPLv3+")
set(IDENTIFIER "org.msxpertsuite")


message("")
message(STATUS "${BoldGreen}Starting configuration of msXpertSuite${ColourReset}")
message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message("")


# No need to specify position independent code flag on MING64_NT
# because that flag is set automatically and it triggers an error when -Werror
# is set.
if(NOT WIN64)
	ADD_DEFINITIONS(-fPIC)
endif()

if(APPLE)
	add_definitions("-stdlib=libc++")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	message(STATUS "using ${CMAKE_CXX_FLAGS}")
endif()

########################################################
# Source tree preparation
# On windows and mac, some libraries are added to the source tree
# while on Debian GNU/Linux there libraries are packaged.
########################################################

if(APPLE OR WIN64)

	message(STATUS "should copy the qcustomplot directory.")

	# This include must come before all the others
	# It must include the config-generated config.h file
	# before the others.
	include_directories(${CMAKE_BINARY_DIR})

	# Copy the qcustomplot directory to the source tree
	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/qcustomplot
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(QCUSTOMPLOT_SRC_DIR ${CMAKE_SOURCE_DIR}/qcustomplot)
	include_directories(${QCUSTOMPLOT_SRC_DIR})

	# Copy the tclap directory to the source tree
	message(STATUS "should copy the tclap directory.")

	execute_process(COMMAND cp -vrp ${CMAKE_SOURCE_DIR}/../helper-libs/tclap
		${CMAKE_SOURCE_DIR}
		WORKING_DIRECTORY	${CMAKE_SOURCE_DIR})

	set(TCLAP_SRC_DIR ${CMAKE_SOURCE_DIR}/tclap)
	include_directories(${CMAKE_SOURCE_DIR})

endif()



#############################################################
# On MINGW.* we provide a number of libraries by our own, that we
# put mingw64/usr/local/lib
if(WIN64)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -L/mingw64/usr/local/lib")
endif()


#############################################################
# Enable warnings and possibly treat them as errors
add_definitions(-Wall)

if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors.${ColourReset}")
	add_definitions(-Werror)
endif()

# On MINGW64_NT, we want to build as release, otherwise build as debug.
if(WIN64)
	set(CMAKE_BUILD_TYPE "release")
	add_definitions(-DQT_NO_DEBUG)
else()
	if(NOT CMAKE_BUILD_TYPE STREQUAL "release")
		set(CMAKE_BUILD_TYPE "debug")
	endif()
endif()

# But the user may want something easier to set: -DDEBUG
if(DEBUG)
	set(CMAKE_BUILD_TYPE "debug")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "debug")
	add_definitions(-g -O0)
	message(STATUS "${BoldYellow}Debug support requested. Adding -g -O0.${ColourReset}")
else()
	add_definitions(-O3)
	message(STATUS "${BoldYellow}Debug support NOT requested. Adding -O3.${ColourReset}")
endif()

if(APPLE)
	link_directories("/opt/local/lib")
endif()

if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested, adding -fopenmp flag.${ColourReset}")
	if(APPLE)
		include_directories("/opt/local/include/libomp")
		link_directories("/opt/local/lib/libomp")
	else()
		add_definitions(-fopenmp)
	endif()

	# Depending on the compiler, if we need the omp.h header file,
	# we'll have to look for it in different locations.

	message(STATUS "${BoldRed}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
	message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")

	if(CMAKE_CXX_COMPILER MATCHES ".*clang.*")
		message(STATUS "${BoldRed}Using clang++${ColourReset}")
		include_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		link_directories("${CMAKE_SOURCE_DIR}/clang-openmp")
		set(OPENMP_LIBRARY omp)
	else()
		message(STATUS "${BoldRed}Not using clang++${ColourReset}")
		set(OPENMP_LIBRARY gomp)
	endif()

	message(STATUS "${BoldYellow}Using parallelizing library ${OPENMP_LIBRARY}${ColourReset}")
endif()

if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested, adding -pg flag.${ColourReset}")
	add_definitions(-pg)
endif()


message(STATUS "${BoldYellow}Main CMAKE_BINARY_DIR: ${CMAKE_BINARY_DIR}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

# For the config.h file.
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(globals)
add_subdirectory(libmass)
add_subdirectory(libmassgui)

# It is essential to run these config steps before delving into the massxpert
# and minexpert directories, because at that moment they will need what are
# going to prepare right now.
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/splashscreen.svg.in
	${CMAKE_SOURCE_DIR}/images/splashscreen.svg @ONLY)

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-macros.tex.in
	${CMAKE_SOURCE_DIR}/user-manual-common/texfiles/msxpertsuite-macros.tex @ONLY)

# Make the conversion of the svg file into a png, but only on GNU/Linux
if(UNIX AND NOT APPLE)
	execute_process(COMMAND convert ${CMAKE_SOURCE_DIR}/images/splashscreen.svg
		${CMAKE_SOURCE_DIR}/images/splashscreen.png)
endif()

add_subdirectory(massxpert)
get_directory_property(CMAKE_INSTALL_PREFIX
	DIRECTORY massxpert
	CMAKE_INSTALL_PREFIX)

get_directory_property(MSXPERTSUITE_DOC_DIR
	DIRECTORY massxpert
	MSXPERTSUITE_DOC_DIR)

add_subdirectory(minexpert)

add_subdirectory(doc)

add_subdirectory(devdoc)

if(TESTS)
	add_subdirectory(tests)
endif()

CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/msxpertsuite-mingw64-win7+.iss.in
	${CMAKE_SOURCE_DIR}/winInstaller/msxpertsuite-mingw64-win7+.iss @ONLY)

#############################################################
# summary
message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message(STATUS "${BoldRed}   General configuration of the msXpertSuite project ${ColourReset}")
message("")
message(STATUS "${BoldYellow}System is detected by CMake as ${SYSTEM_UNAME_S}${ColourReset}")
message(STATUS "${BoldYellow}CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}${ColourReset}")
message(STATUS "${BoldYellow}MSXPERTSUITE_BIN_DIR: ${MSXPERTSUITE_BIN_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MSXPERTSUITE_DATA_DIR: ${MSXPERTSUITE_DATA_DIR}${ColourReset}")
message(STATUS "${BoldYellow}MSXPERTSUITE_DOC_DIR: ${MSXPERTSUITE_DOC_DIR}${ColourReset}")

if(PROFILE)
	message(STATUS "${BoldYellow}Profiling is requested (-DPROFILE=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Profiling is NOT requested (-DPROFILE=0)${ColourReset}")
endif()

if(OPENMP)
	message(STATUS "${BoldYellow}OpenMP support is requested (-DOPENMP=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}OpenMP support is NOT requested (-DOPENMP=0)${ColourReset}")
endif()

if(WARNASERR)
	message(STATUS "${BoldYellow}Warnings treated as errors (-DWARNASERR=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Warnings NOT treated as errors (-DWARNASERR=0)${ColourReset}")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "debug")
	message(STATUS "${BoldYellow}Debug support requested (-DDEBUG=1)${ColourReset}")
else()
	message(STATUS "${BoldYellow}Debug support NOT requested (-DDEBUG=0)${ColourReset}")
endif()

message(STATUS "${BoldYellow}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")
message("")
message(STATUS "${BoldYellow}You can ask for clang++ by issuing the following command: $CXX=clang++ cmake -DOPENMP=1 -DDEBUG=1 ../development/${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on mingw64 would be: $cmake -DOPENMP=1 -DDEBUG=0 ../development -DCMAKE_CXX_COMPILER=/mingw64/bin/g++.exe ${ColourReset}")
message(STATUS "${BoldYellow}The typical cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldYellow}The typical DeveloperMode cmake invocation on Debian GNU/Linux would be: $cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=1 -DBUILD_USER_MANUALS=1 ../development${ColourReset}")
message("")
message(STATUS "${BoldYellow}To build the tests, add the -DTESTS=1 flag to the cmake command line: $cmake -DOPENMP=1 -DDEBUG=1 -DDEVMODE=1 -DBUILD_USER_MANUALS=1 -DTESTS=1 ../development${ColourReset}")



message("")
message(STATUS "${BoldRed}~~~~~~~~~~~~~~~~~~~~~~~~ SUMMARY ~~~~~~~~~~~~~~~~~~~~~~~~${ColourReset}")
message("")

=== debian/changelog ===
msxpertsuite (5.2.0-1) unstable; urgency=low

  * New upstream release.

  * Fix bug with the mzML to SQLite3 db conversion due to not allocation
    QCoreApplication before running the console-based conversion (MS Windows
    only bug, apparently).

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 25 May 2018 12:50:59 +0200

## msxpertsuite 5.2.1

=== debian/changelog ===
msxpertsuite (5.2.1-1) unstable; urgency=low

  * New upstream release.

  * Fix integration help string that had bad keyboard key information to
    integrate to XIC chromatogram.

 -- Filippo Rusconi <lopippo@debian.org>  Tue, 29 May 2018 14:41:25 +0200

## msxpertsuite 5.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,7 +28,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.2.0)
+set(VERSION 5.3.0)
 
 
 # Set additional project information

=== debian/changelog ===
msxpertsuite (5.3.0-1) unstable; urgency=low

  * New upstream release.

  * Ensure that the QScript JavaScript environment works flawlessly even in
    the context of QThread-based code. Written JS-specific functions for
    where QThread would be a problem.

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 31 May 2018 14:10:03 +0200

## msxpertsuite 5.3.2

=== debian/changelog ===
msxpertsuite (5.3.2-1) unstable; urgency=low

  * New upstream release.

  * General revision of the JavaScript reference documentation. Fixes and
    additions.

  * Small fixes.

 -- Filippo Rusconi <lopippo@debian.org>  Mon, 04 Jun 2018 22:33:37 +0200

msxpertsuite (5.3.1-1) unstable; urgency=low

  * New upstream release.

  * Make sure it is possible to record [start-end] ranges for TIC intensity
    computations in the TIC chromatogram and drift spectrum widgets.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 01 Jun 2018 16:32:11 +0200

## msxpertsuite 5.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,8 +13,14 @@
 # youcompleteme (vim plugin).
 set(CMAKE_EXPORT_COMPILE_COMMANDS 1)
 
-# We want C++14
-ADD_DEFINITIONS(-std=c++14 -Wno-unknown-pragmas)
+# We want C++11
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+# deprecated, cmake does the job: ADD_DEFINITIONS(-std=c++11)
+
+# We do not want warnings for unknown pragmas:
+ADD_DEFINITIONS(-Wno-unknown-pragmas)
 
 # Include the various colors we want to use in the output
 include(outputColors)
@@ -28,7 +34,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.3.0)
+set(VERSION 5.3.3)
 
 
 # Set additional project information

=== devdoc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuring of the devdoc material${ColourReset}")
message("")

# The developer documentation.
if(UNIX AND NOT APPLE)

	# Command:
	# make devdoc
	add_custom_target(devdoc
		COMMAND doxygen msxpertsuite.doxyconf
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "Doxygen-based developer documentation generation")

	# Make sure we use the qtchooser command to run the qhelpgenerator command
	# qtchooser --run-tool=qhelpgenerator -qt=5 -o html/msxpertsuite.qch html/index.qhp

	# Command:
	# make qthelp
	add_custom_target(qthelp
		COMMAND qtchooser --run-tool=qhelpgenerator -qt=5 -o html/msxpertsuite.qch html/index.qhp
		COMMAND touch /tmp/this-is-the-touch
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "Build the Qt Assistant indexed file.")

	# Make sure the qtAssistantHelp target depends on the devdoc target since
	# html/index.qhp is created upon making devdoc.
	add_dependencies(qthelp devdoc)

endif(UNIX AND NOT APPLE)


###############
# install stuff

if(UNIX AND NOT APPLE)
	install(DIRECTORY html
		DESTINATION ${MSXPERTSUITE_DOC_DIR})
endif()

message("")
message(STATUS "${BoldGreen}Finished configuring of the devdoc material${ColourReset}")
message("")

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuring of the doc material${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man msxpertsuite.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-doc.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-doc.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-dev-doc.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-dev-doc.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man msxpertsuite-data.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/msxpertsuite-data.7
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man massxpert.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/massxpert.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

	execute_process(COMMAND docbook-to-man minexpert.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/minexpert.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff

if(NOT APPLE)
	# The history file (the html-formatted file is loaded dynamically by the
	# AboutDlg class and derived classes).
	install(FILES history.odt history.html readme.txt COPYING
		DESTINATION ${MSXPERTSUITE_DOC_DIR})
endif()

if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/msxpertsuite.7
		${CMAKE_BINARY_DIR}/msxpertsuite-doc.7
		${CMAKE_BINARY_DIR}/msxpertsuite-dev-doc.7
		${CMAKE_BINARY_DIR}/msxpertsuite-data.7
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man7)

	install(FILES ${CMAKE_BINARY_DIR}/massxpert.1
		${CMAKE_BINARY_DIR}/minexpert.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()

message("")
message(STATUS "${BoldGreen}Finished configuring of the doc material${ColourReset}")
message("")

=== libmass/CMakeLists.txt ===
# Get the name of the current directory but with no path:
get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

message("")
message(STATUS "${BoldGreen}Start processing ${TARGET} dir.${ColourReset}")
message("")

########################################################
# Files

file(GLOB mass_SRCS *.cpp)
file(GLOB glob_SRCS ../globals/*.cpp)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(CMAKE_BUILD_TYPE "release")
else()
	set(CMAKE_BUILD_TYPE "debug")
endif()

find_package(Qt5 COMPONENTS Core Xml Svg Sql Script)

add_library(mass STATIC
	${mass_SRCS}
	${glob_SRCS})

qt5_use_modules(mass Xml)
qt5_use_modules(mass Svg)
qt5_use_modules(mass Sql)
qt5_use_modules(mass Script)

include_directories(
	# For the config file that is in the top binary dir.
	${CMAKE_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}

	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS})


# On MINGW.* we provide a number of libraries by our own, that we
# put in /usr/local/lib under /mingw64/.
if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -L/mingw64/usr/local/lib")
endif()


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	include_directories(/mingw64/include/pwiz)
elseif(APPLE)
	include_directories(/opt/local/include/pwiz)
	link_directories(/opt/local/lib/)
else()
	include_directories(/usr/include/pwiz)
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)


##############################################################
# libboost_* on mingw
# On MINGW.* and mac we are our own provider of the boost libraries.
if(APPLE OR (SYSTEM_UNAME_S MATCHES "^MINGW.*"))

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
		include_directories(${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0)
	elseif(APPLE)
		include_directories(/opt/local/include)
		include_directories(/opt/local/include/pwiz/libraries/boost_aux)
	endif()

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)
endif()


# Use the Widgets module from Qt 5. We craft a variable for this so as to
# transmit it directly to the tests subdirectory that will need it.
# Also, take the opportunity to ask for linking of the libgomp or lomp OPENMP
# library, depending on the compiler.

message(STATUS "${BoldYellow}Using parallelizing library ${OPENMP_LIBRARY}${ColourReset}")

set(required_target_link_libraries
	${required_target_link_libraries}
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	${OPENMP_LIBRARY})

# on MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(SYSTEM_UNAME_S MATCHES "^MINGW.*")
	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")
endif()


#### Debugging stuff
#message(STATUS required_target_link_libraries: ${required_target_link_libraries})
#get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
#foreach(dir ${dirs})
#message(STATUS "included dir='${dir}'")
#endforeach()


# Finally actually set the liking dependencies to the library.
target_link_libraries(mass
	${required_target_link_libraries})



message(STATUS "${TARGET} CMAKE_CURRENT_BINARY_DIR: ${CMAKE_CURRENT_BINARY_DIR}")
message(STATUS "Qt5Xml: " ${Qt5Xml_INCLUDE_DIRS})
message(STATUS "Qt5Svg: " ${Qt5Svg_INCLUDE_DIRS})
message(STATUS "Qt5Sql: " ${Qt5Sql_INCLUDE_DIRS})
message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")


message("")
message(STATUS "${BoldGreen}Finished processing ${TARGET} dir.${ColourReset}")
message("")

=== minexpert/CMakeLists.txt ===
# Get the name of the current directory but with no path:
#get_filename_component(TARGET ${CMAKE_CURRENT_BINARY_DIR} NAME)

# ${TARGET}-objlib will be the name of the object files collection (in CMake
# parlance that is an "OBJECT" library type. In that library, that is simply a
# list of compiled object files, I put all the *.o files that make the ${TARGET}
# (minexpert or massxpert) executable image file, but not main.cpp. This is done
# because when building the tests/tests binary for tests relating to ${TARGET},
# I'll reuse these compiled object files.

if(APPLE)
	set(TARGET mineXpert)
	message(STATUS "APPLE: ${TARGET}")
elseif(UNIX AND NOT APPLE)
	set(TARGET minexpert)
	message(STATUS "NON-APPLE: ${TARGET}")
elseif(WIN64)
	set(TARGET mineXpert.exe)
	message(STATUS "WIN64: ${TARGET}")
endif()

set(TITLE_TARGET "mineXpert")
set(DOCTARGET "minexpert")
set(MINEXPERT_TARGET ${TARGET})

# Prepare the name the target module so that we can query it
# from the parent directory.
set_directory_properties(PROPERTIES MINEXPERT_TARGET ${MINEXPERT_TARGET})

message("")
message(STATUS "${BoldGreen}Starting configuring of the ${TARGET} submodule${ColourReset}")
message("")


#############################################################
# Software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

########################################################
# Files
file(GLOB ${TARGET}-objlib_nongui_SRCS nongui/*.cpp)
file(GLOB ${TARGET}-objlib_gui_SRCS gui/*.cpp)
file(GLOB ${TARGET}-objlib_UIS gui/ui/*.ui)

# The only file that does not enter in the object library of
# object files (see notice above).
file(GLOB ${TARGET}-exec_SRCS main.cpp)

# The desktop file
if(UNIX AND NOT APPLE)
	install(FILES ${TARGET}.desktop
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
endif()

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

find_package(Qt5 COMPONENTS Widgets Xml Svg Sql Script PrintSupport)

qt5_wrap_ui(${TARGET}-objlib_UIS_H ${${TARGET}-objlib_UIS})

qt5_add_resources(${TARGET}_QRC_CPP gui/application.qrc)

### These two lines required because now CMake only automocs
### the generated files and not the source files.
set_source_files_properties(${${TARGET}-objlib_UIS_H} PROPERTIES SKIP_AUTOMOC ON)
set_source_files_properties(${${TARGET}_QRC_CPP} PROPERTIES SKIP_AUTOMOC ON)


add_library(${TARGET}-objlib OBJECT
	${${TARGET}-objlib_nongui_SRCS}
	${${TARGET}-objlib_gui_SRCS}
	${${TARGET}-objlib_UIS_H})

###############################################################
# Configuration of the binary to be built
###############################################################

# Only now can we add the executable, because we have defined the sources of the
# object library above.

if(NOT APPLE)

	add_executable(${TARGET}
		${${TARGET}-exec_SRCS}
		$<TARGET_OBJECTS:${TARGET}-objlib>
		${${TARGET}_QRC_CPP})

else()

	# Copy the icon file to the Contents/Resources directory of the bundle at
	# location ${MACOSX_PACKAGE_LOCATION}.
	set_source_files_properties(../images/msXpertSuite.icns PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

	# Identify MacOS bundle

	set(MACOSX_BUNDLE_BUNDLE_NAME ${TARGET})
	message(STATUS "MACOSX_BUNDLE_BUNDLE_NAME: ${MACOSX_BUNDLE_BUNDLE_NAME}")

	set(MACOSX_BUNDLE_BUNDLE_VERSION ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_LONG_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING ${PROJECT_VERSION})
	set(MACOSX_BUNDLE_COPYRIGHT ${COPYRIGHT})
	set(MACOSX_BUNDLE_GUI_IDENTIFIER ${IDENTIFIER})
	set(MACOSX_BUNDLE_ICON_FILE ../images/msXpertSuite.icns)

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mmacosx-version-min=10.9"
		CACHE STRING "Flags used by the compiler during all build types." FORCE)

	#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden"
	#CACHE STRING "Flags used by the compiler during all build types." FORCE)

	set(CMAKE_OSX_SYSROOT "/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.12.sdk/"
		CACHE STRING "MacOSX10.12.sdk." FORCE)

	add_executable(${TARGET} MACOSX_BUNDLE
		${${TARGET}-exec_SRCS}
		$<TARGET_OBJECTS:${TARGET}-objlib>
		${${TARGET}_QRC_CPP}
		../images/msXpertSuite.icns
		)

	set_target_properties(${TARGET} PROPERTIES MACOSX_BUNDLE_ICON_FILE msXpertSuite.icns)

endif()


###############################################################
# Installation directories depending on the platform and module
###############################################################

if(WIN64)

	set(CMAKE_INSTALL_PREFIX "C:/Program Files/msXpertSuite")

	message(STATUS "${BoldYellow}Detected WIN64. Install prefix set to ${CMAKE_INSTALL_PREFIX}${ColourReset}")

	set(MSXPERTSUITE_BIN_DIR ${CMAKE_INSTALL_PREFIX})
	set(MSXPERTSUITE_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data/${TARGET})
	set(MSXPERTSUITE_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc)

elseif(UNIX AND NOT APPLE)

	message(STATUS "${BoldYellow}Detected UNIX NOT APPLE.${ColourReset}")
	#set(CMAKE_INSTALL_PREFIX "/usr/local")
	set(MSXPERTSUITE_BIN_DIR ${CMAKE_INSTALL_PREFIX}/bin)
	set(MSXPERTSUITE_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/msxpertsuite/${TARGET})
	set(MSXPERTSUITE_DOC_DIR ${CMAKE_INSTALL_PREFIX}/share/doc/msxpertsuite)

elseif(APPLE)
	message(STATUS "${BoldYellow}Detected APPLE.${ColourReset}")

	# At this point, we need to make sure we configure the install directories
	# specifically for APPLE:

	set(BUNDLE_DIR ${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.app)
	set(CMAKE_INSTALL_PREFIX "${BUNDLE_DIR}/Contents")
	set(MSXPERTSUITE_BIN_DIR ${BUNDLE_DIR}/Contents/MacOS)
	set(MSXPERTSUITE_DATA_DIR ${BUNDLE_DIR}/Contents/Resources/data)
	set(MSXPERTSUITE_DOC_DIR ${BUNDLE_DIR}/Contents/doc)

endif()

message(STATUS "CMAKE_INSTALL_PREFIX: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "MSXPERTSUITE_BIN_DIR: ${MSXPERTSUITE_BIN_DIR}")
message(STATUS "MSXPERTSUITE_DATA_DIR: ${MSXPERTSUITE_DATA_DIR}")
message(STATUS "MSXPERTSUITE_DOC_DIR: ${MSXPERTSUITE_DOC_DIR}")

# Use all the configured paths to create the config.h file.
# The config file is binary directory-specific !!!
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/config.h.in
	${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

qt5_use_modules(${TARGET} Widgets)
qt5_use_modules(${TARGET} Xml)
qt5_use_modules(${TARGET} Svg)
qt5_use_modules(${TARGET} Sql)
qt5_use_modules(${TARGET} Script)
qt5_use_modules(${TARGET} PrintSupport)

include_directories(

	# The config file is binary directory-specific !!!
	# For the config.h file generated from config.h.in
	# For the ui_Xyyyyy.h files
	${CMAKE_CURRENT_BINARY_DIR}

	# For all the source subdirectories
	${CMAKE_SOURCE_DIR}

	${CMAKE_BINARY_DIR}/libmassgui

	${Qt5Widgets_INCLUDE_DIRS}
	${Qt5Xml_INCLUDE_DIRS}
	${Qt5Svg_INCLUDE_DIRS}
	${Qt5Sql_INCLUDE_DIRS}
	${Qt5Script_INCLUDE_DIRS}
	${Qt5PrintSupport_INCLUDE_DIRS})


# On GNU/Linux, make sure we have the QCustomPlot library
# installed on the system (on MINGW, we have the
# source files (see above).
if(NOT WIN64 AND NOT APPLE)

	find_package(QCustomPlot)

	if(NOT QCustomPlot_FOUND)
		message(FATAL_ERROR "QCustomPlot not found!")
	else()
		message(STATUS "QCustomPlot found!")
	endif()

endif()

# Now handle the private libraries for non-gui stuff (libmass.a) and gui stuff
# (libmassgui.a)
if(APPLE)

	set(MASSLIB "${CMAKE_BINARY_DIR}/libmass/libmass.a")
	set(MASSGUILIB "${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

else()

	set(MASSLIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmass/libmass.a -Wl,-no-whole-archive")
	set(MASSGUILIB "-Wl,-whole-archive ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a -Wl,-no-whole-archive")

endif()

message(STATUS "libdir: ${CMAKE_BINARY_DIR}/libmass/libmass.a")
message(STATUS "guilibdir: ${CMAKE_BINARY_DIR}/libmassgui/libmassgui.a")

message(STATUS "Using parallelizing library ${OPENMP_LIBRARY}")

set(required_target_link_libraries
	${MASSLIB}
	${MASSGUILIB}
	${OPENMP_LIBRARY}
	Qt5::Widgets
	Qt5::Xml
	Qt5::Svg
	Qt5::Sql
	Qt5::Script
	Qt5::PrintSupport)


##############################################################
# libpwiz for reading mass spec data files,
message(STATUS "${BoldYellow}Link against the libpwiz library.${ColourReset}")
if(WIN64)
	include_directories("/mingw64/include/pwiz")
elseif(APPLE)
	include_directories("/opt/local/include/pwiz")
	link_directories("/opt/local/lib")
else()
	include_directories("/usr/include/pwiz")
endif()

set(required_target_link_libraries
	${required_target_link_libraries}
	pwiz)

##############################################################
# libboost_* on mingw
# On MINGW.* we are our own provider of the boost libraries.
if(WIN64)

	message(STATUS "${BoldYellow}Link against the libboost libraries.${ColourReset}")

	include_directories("${CMAKE_SOURCE_DIR}/../../boost/boost_1_56_0")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono
		boost_filesystem
		boost_iostreams
		boost_program_options
		boost_serialization
		boost_system
		boost_thread
		z)

elseif(APPLE)
	# With macport
	include_directories("/opt/local/include")
	# Attention #####
	# below for
	# /opt/local/include/pwiz/libraries/boost_aux/boost/utility/singleton.hpp
	include_directories("/opt/local/include/pwiz/libraries/boost_aux")
	link_directories("/opt/local/lib")

	set(required_target_link_libraries
		${required_target_link_libraries}
		boost_chrono-mt
		boost_filesystem-mt
		boost_iostreams-mt
		boost_program_options-mt
		boost_serialization-mt
		boost_system-mt
		boost_thread-mt
		z)

endif()

# On MINGW.*, we'll need to add the -lstdc++ flag. Don't ask why.
if(WIN64)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"stdc++")

endif()

# When on UNIX/NOT APPLE we can make use the system-wide qcustomplot library.
if(UNIX AND NOT APPLE)

	set(required_target_link_libraries
		${required_target_link_libraries}
		"qcustomplot")

endif()


#### Debugging stuff
message(STATUS required_target_link_libraries: ${required_target_link_libraries})

message(STATUS "Now printing all the include directories -I...")

get_property(dirs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY INCLUDE_DIRECTORIES)
foreach(dir ${dirs})
	message(STATUS "included dir='${dir}'")
endforeach()

message(STATUS "Now printing all the linking directories -L...")

get_property(dirs DIRECTORY PROPERTY LINK_DIRECTORIES)
foreach(dir ${dirs})
	message(STATUS "link directory dir='${dir}'")
endforeach()

# Finally actually set the linking dependencies to the executable.
target_link_libraries(${TARGET}
	${required_target_link_libraries})


# Add an explicit dependency to libmass and libmassgui so that when invoking
# make from inside the massxpert bin build dir, the dependencies get built.
add_dependencies(${TARGET} mass massgui)

if(PROFILE)
	message(STATUS "Profiling is requested, adding linker -pg flag.")
	set (CMAKE_EXE_LINKER_FLAGS "-pg")
endif()

if(NOT APPLE)
	# We want to install the binary arch-dependent target in
	# specific situations. To have proper control, we define the arch
	# component.
	install(TARGETS ${TARGET}
		RUNTIME
		COMPONENT arch
		DESTINATION ${MSXPERTSUITE_BIN_DIR})
endif()


#############################################################
##########################
# EXTRACTION OF THE JAVASCRIPT-RELATED DOCUMENTATION FROM THE SOURCE FILES

if(UNIX AND NOT APPLE)
	if(DEVMODE)

		message(STATUS "${TITLE_TARGET} extracting JavaScript-related documentation")
		execute_process(COMMAND devdoc/scripts/jsExtract.py -i libmass/DataPointJs.cpp
			libmass/DataPointJsPrototype.cpp
			minexpert/nongui/SavGolParamsJSDoc.cpp
			minexpert/nongui/SavGolFilterJs.cpp minexpert/nongui/SavGolFilterJsPrototype.cpp
			minexpert/nongui/MzIntegrationParamsJs.cpp minexpert/nongui/MzIntegrationParamsJsPrototype.cpp
			libmass/TraceJs.cpp libmass/TraceJsPrototype.cpp
			libmass/MassSpectrumJs.cpp libmass/MassSpectrumJsPrototype.cpp
			minexpert/gui/AbstractPlotWidget.cpp minexpert/gui/ColorMapPlotWidget.cpp
			minexpert/gui/TicChromPlotWidget.cpp minexpert/gui/MassSpecPlotWidget.cpp

=== minexpert/user-manual/CMakeLists.txt ===
message(STATUS "\nStarting configuring of the ${DOCTARGET}-user-manual material\n")

#############################################################
# There are warning issued during the compilation of almost
# any LaTeX source, but we want the compilation not to stop...
# Because the build process has -Werror set globally we want to
# disable it here specifically.
if(PEDANTIC)
	REMOVE_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

	set(CUR_DOC_DIR ${CMAKE_SOURCE_DIR}/${DOCTARGET}/user-manual)
	set(CUR_DOC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/build-user-manual)

	message(STATUS "Current doc directory: ${CUR_DOC_DIR}")
	message(STATUS "Current doc build directory: ${CUR_DOC_BUILD_DIR}")

	# Copy the directory to a build directory. This will also copy as "hard"
	# files, following the various symbolic links,  to other files in other places
	# in the source tree (preface.tex is an example, images/splashscreen.png or
	# images/addresses.png are two other examples; the files in
	# user-manual-common/figures that are linked in the local figures directory
	# also).
	execute_process(COMMAND cp -rpL ${CUR_DOC_DIR} ${CUR_DOC_BUILD_DIR}
		WORKING_DIRECTORY	${CMAKE_CURRENT_BINARY_DIR})

	# Make sure we use the Makefile that is located in the new directory, copy
	# of the original user-manual directory.
	add_custom_command(OUTPUT ${DOCTARGET}-doc.pdf
		COMMAND make -f ${CUR_DOC_BUILD_DIR}/Makefile usermanual
		WORKING_DIRECTORY ${CUR_DOC_BUILD_DIR}
		COMMENT "Build the ${DOCTARGET} user manual")

	if(BUILD_USER_MANUALS)

		# Command:
		# make ${DOCTARGET}-user-manual
		add_custom_target(${DOCTARGET}-user-manual ALL
			DEPENDS ${DOCTARGET}-doc.pdf
			COMMENT "Make ${DOCTARGET}-user-manual")

		# Command:
		# make copy-${DOCTARGET}-doc.pdf
		add_custom_target(copy-${DOCTARGET}-doc.pdf ALL
			COMMAND ${CMAKE_COMMAND} -E copy ${CUR_DOC_BUILD_DIR}/${DOCTARGET}-doc.pdf
			${CMAKE_SOURCE_DIR}/${DOCTARGET}/user-manual
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${DOCTARGET}-doc.pdf
			COMMENT "Copy the pdf file to the source doc dir.")

	endif()

endif()

if(PEDANTIC)
	ADD_DEFINITIONS (-Werror)
endif(PEDANTIC)

if(UNIX AND NOT APPLE)

	install(FILES ${CUR_DOC_BUILD_DIR}/${DOCTARGET}-doc.pdf
		DESTINATION ${MSXPERTSUITE_DOC_DIR})

elseif(APPLE)

	install(FILES ${CMAKE_SOURCE_DIR}/${DOCTARGET}/user-manual/${DOCTARGET}-doc.pdf
		DESTINATION ${MSXPERTSUITE_DOC_DIR})

endif()

message(STATUS "\nFinished configuring of the ${DOCTARGET}-user-manual material\n")

=== debian/changelog ===
msxpertsuite (5.3.3-1) unstable; urgency=low

  * New upstream release.

  * Fix the "ignore error" directive in the user manual documentation Makefile
    that drives the LaTeX-based compilation of the documents (Closes: #901154);

  * Revert C++14 to C++11 to maintain compatibility with OSes that are less
    advanced with gcc;

  * Fix problem with loading Agilent data because of drift bin count variable.

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 20 Jun 2018 17:42:48 +0200

## msxpertsuite 5.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,7 @@
 # Basic information about project
 
 project(msXpertSuite)
-set(VERSION 5.3.3)
+set(VERSION 5.6.0)
 
 
 # Set additional project information

=== minexpert/javascript/CMakeLists.txt ===
###############
# install stuff

INSTALL (DIRECTORY scripts
	DESTINATION ${MSXPERTSUITE_JAVASCRIPT_DIR})

=== debian/rules ===
--- 
+++ 
@@ -68,8 +68,6 @@
 	rm -f massxpert/user-manual/massxpert-doc.pdf \
 		minexpert/user-manual/minexpert-doc.pdf
 
-# Remove all the doxygen-generated developer documentation.
-	rm -rf devdoc/html
 
 build-indep-stamp:
 	dh_testdir
@@ -89,14 +87,6 @@
 	cd $(BUILD_DIR) && $(MAKE) -j1 massxpert-user-manual
 
 	cd $(BUILD_DIR) && $(MAKE) -j1 minexpert-user-manual
-
-	# The qthelp target depends on the devdoc target
-	# that is responsible for compiling the Doxygen-based documentation
-	cd $(BUILD_DIR) && $(MAKE) qthelp
-
-	rm devdoc/html/jquery.js
-
-	find devdoc/html -name "*.md5" | xargs rm
 
 	touch build-indep-stamp
